Draft Offset: Difference between revisions

From FreeCAD Documentation
(Draft Scale is a similar tool)
(Use shift to lock the current reference edge)
Line 26: Line 26:
# Select objects you wish to offset.
# Select objects you wish to offset.
# Press the {{Button|[[Image:Draft Offset.png|16px]] [[Draft Offset]]}} button, or press {{KEY|O}} then {{KEY|S}} keys.
# Press the {{Button|[[Image:Draft Offset.png|16px]] [[Draft Offset]]}} button, or press {{KEY|O}} then {{KEY|S}} keys.
# Click a point on the 3D view, or type a distance. This distance is perpendicular to one of the edges of the original shape.
# Click a point on the 3D view, or type a distance.

The distance used to create the offset is perpendicular to one of the edges of the original shape, depending on the position of the pointer. If the pointer is moved closer to another edge, this edge now becomes the reference for the distance. Hold the {{KEY|Shift}} key to keep the current reference edge despite moving the pointer closer to other edges.


==Options== <!--T:6-->
==Options== <!--T:6-->

Revision as of 00:46, 13 November 2018

Draft Offset

Menu location
Draft → Offset
Workbenches
Draft, Arch
Default shortcut
O S
Introduced in version
-
See also
Draft Scale, Part 2D Offset

Description

The Offset tool moves the selected object by a given distance (offset) perpendicular to itself. If no object is selected, you will be invited to select one.

Typically this tool is used in copy mode to create offset copies of a base object while leaving this object in the same place. The offset copies are slightly scaled versions of the original object. To create other scaled copies use Draft Scale. To produce exact copies shifted a distance use Draft Move.

How to use

  1. Select objects you wish to offset.
  2. Press the Draft Offset button, or press O then S keys.
  3. Click a point on the 3D view, or type a distance.

The distance used to create the offset is perpendicular to one of the edges of the original shape, depending on the position of the pointer. If the pointer is moved closer to another edge, this edge now becomes the reference for the distance. Hold the Shift key to keep the current reference edge despite moving the pointer closer to other edges.

Options

  • Press P or click the checkbox to toggle copy mode. If copy mode is on, the Offset tool will keep the original shape in its place but will make a scaled copy at the chosen point.
  • Hold Alt while picking the point to also toggle copy mode. Keeping Alt pressed will allow you to continue placing offset copies; release Alt to finish the operation and see all offsets.
  • Click the "OCC-style" checkbox to toggle OCC mode. This will create an offset from both sides of an line segment, which will produce a specially closed shape with rounded edges at the end of the lines.
With this style the original line segments will be removed, so use copy mode to preserve the original edges.
  • Hold Ctrl while offsetting to force snapping your point to the nearest snap location, independently of the distance.
  • Hold Shift to keep the offset distance on the current segment, instead of picking another one.
  • Press Esc or the Close button to abort the current command; copies already placed will remain.

Scripting

The Offset tool can by used in macros and from the python console by using the following function:

offset (object,Vector,[copymode],[bind],[sym])
  • Offsets the given wire by applying the given Vector to its first vertex.
  • If copymode is True, another object is created, otherwise the same object gets offsetted.
  • If bind is True, and provided the wire is open, the original and the offsetted wires will be bound by their endpoints, forming a face.
  • If sym is True, the offset is made on both sides, the total width being the length of the given vector.
  • Returns the offsetted object (or its copy if copymode as True).

Example:

import FreeCAD,Draft
Draft.offset(FreeCAD.ActiveDocument.ActiveObject,FreeCAD.Vector(2,2,0))